/*
 * ۼ ¥: 2004. 3. 4.
 *
 */
package net.narusas.facet.ui;

import javax.swing.table.AbstractTableModel;

import net.narusas.facet.Facet;
import net.narusas.facet.Resource;
import net.narusas.facet.Topic;

/**
 * @author Administrator
 *
 */
public class ResourceTableModel extends AbstractTableModel {
	Resource[] _resources;
	Topic[] _topics;
	Facet[] _facets;
	/**
	 * 
	 */
	public ResourceTableModel() {
		super();
	}
	
	public String getColumnName(int col) {
		
		return _facets == null ? null :  _facets[col].getName();
	}

	/* (Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	public int getColumnCount() {
		
		return _facets == null ? 0 : _facets.length;
	}

	/* (Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	public int getRowCount() {
		return _resources == null ? 0 : _resources.length;
	}

	/* (Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	public Object getValueAt(int rowIndex, int columnIndex) {
		if (_resources == null || _topics == null){
			return null;
		}
		return _resources[rowIndex].matchFacet(_facets[columnIndex]);
	}
	
	
	
	
	public void setResources(Resource[] resources){
		_resources= resources;
		super.fireTableDataChanged();
	}
	
	public void setTopics(Topic[] topics){
		_topics = topics;
		super.fireTableDataChanged();
	}

	/**
	 * @param facets
	 */
	public void setFacets(Facet[] facets) {
		_facets = facets;
		super.fireTableStructureChanged();
	}
	

}
