/*
 * Created on 2004. 2. 22.
 *
 */
package net.narusas.daap.server.response.mock;

import java.io.ByteArrayOutputStream;

import net.narusas.daap.server.DaapResponse;
import net.narusas.daap.server.tag.ListTag;

/**
 * @author Jisung, Ahn
 * 
 */
public class MockDatabasesResponse extends ListTag implements DaapResponse {

    /**
     * @param name
     */
    public MockDatabasesResponse(String name) {
        super(name);
    }
    
    public int length() {
        return toDaap().length;
    }

    public byte[] toDaap() {
        int[] data = new int[] { 97, 118, 100, 98, 0, 0, 0, 131, 109, 115, 116,
                116, 0, 0, 0, 4, 0, 0, 0, 200, 109, 117, 116, 121, 0, 0, 0, 1,
                0, 109, 116, 99, 111, 0, 0, 0, 4, 0, 0, 0, 1, 109, 114, 99,
                111, 0, 0, 0, 4, 0, 0, 0, 1, 109, 108, 99, 108, 0, 0, 0, 78,
                109, 108, 105, 116, 0, 0, 0, 70, 109, 105, 105, 100, 0, 0, 0,
                4, 0, 0, 0, 32, 109, 112, 101, 114, 0, 0, 0, 8, 205, 113, 46,
                47, 166, 51, 85, 225, 109, 105, 110, 109, 0, 0, 0, 10, 68, 65,
                65, 80, 84, 101, 115, 116, 48, 49, 109, 105, 109, 99, 0, 0, 0,
                4, 0, 0, 0, 3, 109, 99, 116, 99, 0, 0, 0, 4, 0, 0, 0, 1};

        ByteArrayOutputStream bout = new ByteArrayOutputStream();
        for (int i = 0; i < data.length; i++) {
            bout.write(data[i]);
        }
        return bout.toByteArray();
    }

    public ListTag getResponse() {

        return this;
    }
}
