/*
 * Created on 2004. 3. 3
 *
 */
package net.narusas.facet;

import java.util.*;

/**
 * @author jsahn
 *
 */
public class ResourceMatch {
	List _resources = new LinkedList();
	
	public ResourceMatch(Resource[] res){
		Utils.addAll(_resources, res);
	}
	
	/**
	 * @param topic1
	 */
	public void addCondition(Topic topic) {
		if (_resources == null ){
			return;
		}
		Resource[] res = topic.getResources() ;		
		if (_resources.size() == 0) {			
			Utils.addAll(_resources, res);
			return;
		}
		
		
		if (res == null) {
			System.out.println("Clear");
			_resources = null;
		}
		else {
			ArrayList temp = new ArrayList();
			Utils.addAll(temp,res);
			_resources.retainAll(temp);
		}
	}
	
	

	/**
	 * @return
	 */
	public Resource[] match() {
		if (_resources == null){
			return null;
		}
		Collections.sort(_resources);		
		return _resources.size() == 0 ? null : (Resource[]) _resources.toArray(new Resource[0]);
	}

}
