/*
 * Created on 2004. 3. 6
 *
 */
package net.narusas.facet.file;

import java.io.File;

import net.narusas.facet.Facet;
import net.narusas.facet.FacetClassifier;
import net.narusas.facet.Topic;

/**
 * @author jsahn
 *
 */
public class FileFacetClassifier extends FacetClassifier {

	private Facet _extFacet;

	/**
	 * @param name
	 */
	public FileFacetClassifier(String name) {
		super(name);
		init();
	}
	
	/**
	 * File õ Facet ʱȭѴ.  
	 */
	private void init() {
		_extFacet = new Facet("file.ext","Ext");
		addFacet(_extFacet);
	}

	public void addFile(File file){
		FileResource res = new FileResource(file);
		Topic topic = _extFacet.getTopic(res.getExt());
		 
		if ( topic == null) {
			topic = _extFacet.createTopic(res.getExt());			
		}
		topic.addResource(res);
		addResource(res);
	}

}
