/*
 * ۼ ¥: 2004. 3. 6.
 *
 */
package net.narusas.facet.file;

import java.io.File;

import net.narusas.facet.*;

/**
 * @author Administrator
 *
 */
public class FileResource extends Resource {
	/**
	 * @param file
	 */
	public FileResource(File file) {
		super(file.getName());
		_location = file.getAbsolutePath();
		_ext = splitExt(getName());	
	}

	private String _ext;
	private String _absolutePath;
	protected String _location;
	/**
	 * @param name
	 */
	

	/**
	 * @param fileLocation
	 */
	private String splitExt(String name) {		
		return name.lastIndexOf(".") == -1 ? null : name.substring(name.lastIndexOf(".")+1); 
	}

	/**
		 * @param id
		 * @param fileLocation
		 */
	public FileResource(String id, String fileLocation) {
		super(id, FileResource.getFileName(fileLocation));
	}

	/**
	 * @param fileLocation
	 */
	static String getFileName(String fileLocation) {
		return fileLocation.substring(fileLocation.lastIndexOf("\\") + 1);
	}

	public Object matchFacet(Facet facet) {
		if ("Name".equals(facet.getId())) {
			return _name;
		}
		else if ("file.ext".equals(facet.getId())) {
			return _ext;
		}
		else if ("file.location".equals(facet.getId())) {
			return _location;
		}
		return (Topic) _topics.get(facet);
	}

	public String getDirectory() {
		if (_absolutePath != null) {
			return _absolutePath;
		}
		File file = new File(_location);
		_absolutePath = file.getAbsolutePath();
		return _absolutePath;
	}

	/**
	 * @return
	 */
	public String getExt() {
		return _ext;
	}

}
