/*
 * ۼ ¥: 2004. 3. 4.
 */
package net.narusas.facet.ui;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;

import net.narusas.facet.Facet;
import net.narusas.facet.Resource;
import net.narusas.facet.Topic;

/**
 * @author Administrator
 *
 */
public class ResourceTable extends JPanel {

	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JTable jTable = null;
	
	private ResourceTableModel model = new ResourceTableModel();
	
	
	/**
	 * This is the default constructor
	 */
	public ResourceTable() {
		super();		
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new java.awt.BorderLayout());
		this.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		this.setSize(300, 200);
	}

	/**
	 * @param resources
	 */
	public void setResources(Resource[] resources) {		
		model.setResources(resources);
		
	}
	
	
	/**
	 * 
	 */
	private void update() {
			
			
	}

	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getJTable() {
		if(jTable == null) {
			jTable = new javax.swing.JTable();
			//jTable.setAutoCreateColumnsFromModel(false);			
			jTable.setModel(model);
		}
		return jTable;
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if(jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setViewportView(getJTable());
		}
		return jScrollPane;
	}
	
	public static void main(String[] args){
		JFrame frame = new JFrame();
		frame.setSize(500, 500);
		
		Resource[] reses = new Resource[] { 
			new Resource("R1"),
			new Resource("R2"),
			new Resource("R3"),
			new Resource("R4"),
			new Resource("R5"),
			new Resource("R6")
		};
			
		
		ResourceTable table = new ResourceTable();
		table.setTopics(new Topic[]{
			new Topic("Name",null),
			new Topic("Date",null)
		});		
		table.setResources(reses);
		frame.getContentPane().add(table,BorderLayout.CENTER);
		frame.pack();
		frame.setVisible(true);
		
	}


	/**
	 * @param topics
	 */
	public void setTopics(Topic[] topics) {
		model.setTopics(topics);
	}
	/**
	 * @param facets
	 */
	public void setFacets(Facet[] facets) {
		model.setFacets(facets);
		
	}

}
